﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;

namespace CategotyXAxisDisplayIssue
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            Data1 = new ObservableCollection<Data>();
            Data2 = new ObservableCollection<Data>();
            DateData = new List<Data1>();

            Random r = new Random();

            DateTime startDate = DateTime.Now.AddDays(-5);
            DateTime endDate = DateTime.Now;

            DateData.Add(new Data1 { Date = startDate });
            Data1.Add(new Data { Date = startDate, Value = (decimal)r.Next(50, 70) });
            Data2.Add(new Data { Date = startDate, Value = (decimal)r.Next(50, 70) });
             
            do
            {
                startDate = startDate.AddHours(1);

                decimal d1Last = Data1.Last().Value;
                decimal d2Last = Data2.Last().Value;

                if (r.NextDouble() > .5)
                {
                    d1Last += 1;
                    d2Last += 1;
                }
                else
                {
                    d1Last -= 1;
                    d2Last -= 1;
                }
                DateData.Add(new Data1 { Date = startDate });
                Data1.Add(new Data { Date = startDate, Value = d1Last });
                Data2.Add(new Data { Date = startDate, Value = d2Last });                

            } while (startDate < endDate);

            DataContext = this;
        }

        public ObservableCollection<Data> Data1 { get; set; }
        public ObservableCollection<Data> Data2 { get; set; }
        public List<Data1> DateData { get; set; }

        ChartInfoStripsBehavior chartStrips = new ChartInfoStripsBehavior();
        private void levelsChartXAxis_Loaded(object sender, RoutedEventArgs e)
        {
            levelsChartXAxis.ItemsSource = DateData;

                DateTime startDate = DateTime.Now.AddDays(-5).Date;
                DateTime endDate = DateTime.Now.AddDays(1).Date;
                int i = 0;
                while (startDate != endDate)
                {
                    InfoStrip info = new InfoStrip
                    {
                        UseDates = true,
                        StartDateString = startDate.ToShortDateString(),
                        EndDateString = startDate.AddDays(1).ToShortDateString(),
                        Fill = i%2 == 0 ? Brushes.Gray : Brushes.AliceBlue,
                        Label = startDate.ToShortDateString(),
                        StripTemplate = LayoutRoot.Resources["VerticalInfoStripTemplate"] as DataTemplate
                    };
                    chartStrips.InfoStrips.Add(info);
                    i++;
                    startDate = startDate.AddDays(1);
                }
               
          

            ChartStripBehaviors.SetChartInfoStrips(xmLineChart, chartStrips);

            Dispatcher.BeginInvoke(new Action(() =>
            {
                chartStrips.Refresh();
            }), System.Windows.Threading.DispatcherPriority.Background, null);
        }
    }

    public class Data
    {
        public DateTime Date { get; set; }
        public decimal Value { get; set; }
    }

    public class Data1
    {
        public DateTime Date { get; set; }
    }
}
